{$G-,R-,S-,N-,E-}
program see_tele;

uses dos,crt,graph;


var pbuf:array[0..12000] of byte;

procedure fillPort(var tab;count:word;port:word); assembler;
asm
   les di,tab
   mov dx,port
   xor cx,cx

{ on supprime le rafraichissement des rams: trs DANGEREUX }
   cli

		mov dx,379h
@2:
		xor cx,cx
@1:
		inc cx
		in al,dx
		and al,0F0h
		cmp al,80h
		je @1
		cmp cx,7
		jb @2


@3:
		xor cx,cx
@4:
		inc cx
		in al,dx
		and al,0F0h
		cmp al,80h
		jnz @4
		cmp cx,40
		jb @3

@5:
		in al,dx
		and al,0F0h
		cmp al,80h
          jne @5

		mov cx,32
@6:		loop @6

   mov al,74h
   out 43h,al
   mov al,00h
   out 41h,al
   mov al,00h
   out 41h,al

   db 9Ah
   dw offset pbuf
   dw seg @data

{ on le remet }
   mov al,74h
   out 43h,al
   mov al,12h
   out 41h,al
   mov al,00h
   out 41h,al

   sti

end;

const linesize1=54;

procedure makepbuf;
var i,p:word;

procedure outb(a:byte);
begin
     pbuf[p]:=a;
     inc(p);
end;

begin
     p:=0;
     for i:=1 to 320 div 2 do begin
{ 1 }
         outb($B1); outb(linesize1);
         outb($F3); outb($6C);

         outb($F8); outb($90);
         outb($F8); outb($90);

         outb($F8); outb($F8);
         outb($F8); outb($90);
{ 3 }
         outb($F8); outb($90);
         outb($B1); outb(linesize1);
         outb($F3); outb($6C);

         outb($F8); outb($90);
         outb($F8); outb($90);

         if (i mod 3)=0 then outb($90) else outb($F8);
         outb($F8);

     end;
     outb($CB);
end;

var inton:boolean;


procedure int8; interrupt;
begin
	IntOn:=true;
	Port[$20]:=$20;
end;

procedure setspeed8(a:word);
begin
	Port[$43]:=$36;
	Port[$40]:=lo(a);
	Port[$40]:=hi(a);
end;


const
	scrline=160;
	linesize=linesize1*2;
	linesize2=(linesize div 8)*8;
     graycode:array[0..15] of byte=(0,1,3,2,7,6,4,5,15,14,12,13,8,9,11,10);
     hex:array[0..15] of char='0123456789ABCDEF';

type dw=record l,h:word end;

var buf:array[0..scrline-1,0..linesize-1] of byte;
	buf1:array[0..scrline-1,0..linesize2-1] of byte;
    adr,i:word;
    ch:char;
    spe,r,incr,nbl,j,k,m,n,tr,s,co,l,c,a:word;
    grdr,grmo:integer;
    reg:registers;
    cvt:array[0..255] of byte;
    pal:array[0..255,0..2] of byte;
    p,incp:longint;
    f:file;
    min,max,b:byte;
    oldint8:pointer;


label next;

begin
     makepbuf;
     directvideo:=false;

     reg.AX:=$13;
     intr($10,reg);

     for i:=0 to 15 do begin
         pal[i,0]:=i*4;
         pal[i,1]:=i*4;
         pal[i,2]:=i*4;
     end;

     reg.AX:=$1012;
     reg.BX:=0;
     reg.CX:=16;
     reg.DX:=ofs(pal);
     reg.ES:=seg(pal);
     intr($10,reg);

     for i:=0 to 255 do begin
         b:=(i shr 4) xor  $8;
		cvt[i]:=graycode[b];
     end;

	assign(f,'tele');
	rewrite(f,1);
	seek(f,4);


repeat

     fillport(buf,0,$379);

	asm
		mov bx,offset cvt
		mov si,offset buf
		mov ax,0A000h
		mov es,ax
		xor di,di
		mov dx,scrline
@2:
          mov cx,linesize1
		push di
@1:
		mov al,[si]
		xlat
		stosb
		mov al,[si+linesize1]
		xlat
		stosb
		inc si
		loop @1
		pop di
		add di,320
		add si,linesize1
		dec dx
		jne @2
	end;

	asm
		mov si,offset buf
		mov di,offset buf1
		mov ax,ds
		mov es,ax
		mov dx,scrline
@2:
          mov cx,linesize2
		push di
		push si
@1:
		mov al,[si]
		xlat
		stosb
		mov al,[si+linesize1]
		xlat
		stosb
		inc si
		loop @1
		pop si
		pop di
		add di,linesize2
		add si,linesize
		dec dx
		jne @2
	end;

     blockwrite(f,buf1,scrline*linesize2);


until keypressed;
	close(f);
end.